#include <stdio.h>
#include <stdlib.h>
#include "filedat.h"

#define FILENUM 10


 typedef struct filedat {
 			FILE *fptr;
 			int recsize;
 			long lastrecno;
 			char *fname;
 			int fileid;
 			} FILEDAT;
 			
  static FILEDAT files[FILENUM];
  
  static int nextfile = 0;

long getnextrecno(int fid)
	{
	return (files[fid].lastrecno);
	}

long setnextrecno(int fid)
	{
	files[fid].lastrecno++;
	return (files[fid].lastrecno);
	}


int openfile(char *filename,int recsize)
	{
	int fid;

	fid = nextfile;
	
	if((files[fid].fptr = fopen(filename, "r+b")) != NULL)
		{
		fseek(files[fid].fptr, 0L, SEEK_SET);
		fscanf(files[fid].fptr,"%ld", &files[fid].lastrecno);
		}
	else 
		if((files[fid].fptr = fopen(filename, "w+b")) != NULL)
			{
			files[fid].lastrecno = 0L;
			fwrite(" ", 1, recsize, files[fid].fptr);  
			}
		else {
			printf("file open error\n");
			exit(1);
			}
			
	files[fid].recsize = recsize;
	files[fid].fname = filename;
	nextfile++;
			
	return fid;
	}

void closefile(int fid)
	{
	fseek(files[fid].fptr,0L, SEEK_SET);
	fprintf(files[fid].fptr,"%ld", files[fid].lastrecno);
	fclose (files[fid].fptr);
	}

void writerec(char *recptr,long recno, int fid)
	{
	fseek(files[fid].fptr, recno * files[fid].recsize , SEEK_SET);
	fwrite(recptr, files[fid].recsize, 1, files[fid].fptr);
	}

long readrec(char *recptr,long recno,int fid)
	{
	long res;
	fseek(files[fid].fptr, recno * files[fid].recsize , SEEK_SET);
	res = fread (recptr, files[fid].recsize, 1, files[fid].fptr);
	return(res);
	}


