#include <stdio.h>
#include "emp.h"
#include "filedat.h"
#include "index.h"

#define NAMELEN 100

	typedef  struct emp_type {
		char name[NAMELEN];
		int  id;
		float salary;
		} EMP;

static int fid;

static EMP input_rec(void);
static void output_rec(EMP);


void construct_emp(char *filename)
	{
	fid = openfile(filename, sizeof(EMP));
	openindex(filename);
	
	}

void destruct_emp(void)
	{
	closefile( fid);
	closeindex();
	}

void add_rec(void)
	{
	EMP emprec;
	
	emprec = input_rec();
	emprec.id = setnextrecno(fid);
	writerec((char*)&emprec, emprec.id, fid);
	addindex(emprec.name, emprec.id);
	}

EMP input_rec(void)
		{
		EMP in_emp;
		printf("\n\tAdding a New Record\n");
		printf("\n\tPlease enter name: ");
		scanf("%*[\n\t ]%[^\n]s", in_emp.name);
		printf("\tPlease enter salary: ");
		scanf("%f", &in_emp.salary);
		return(in_emp);
		}

void print_recs(void)
		{
		printf("\n\tEmployee Records by Name\n");
		print_rec_names();
		}

void print_emp_index(void)
		{
		printf("\n\tThe Index by Nodes\n");
		printindex();
		}

void print_emp_idxfile(void)
		{
		printf("\n\tThe Index File\n");
		print_index_file();
		}

void del_rec(void)
	{
	char name[NAMELEN];
	
		printf("\n\tDeleting an Employee Record\n");
		printf("\n\tPlease enter name for record to be deleted: ");
		scanf("%*[\n\t ]%[^\n]s", name);
		delindex(name);
	}


void get_rec(long recno)
		{
		EMP emprec;

			readrec((char*)&emprec,recno, fid);
			output_rec(emprec);
		}


void output_rec(EMP out_emp)
		{
		printf("\n\t Employee Record \n");
		printf("\t NAME   : %s \n", out_emp.name);
		printf("\t ID     : %d \n", out_emp.id);
		printf("\t SALARY : %.2f\n",out_emp.salary);
		}


void print_emp_file(void)
		{
		EMP emprec;
		long i, lastrecno;

		lastrecno = getnextrecno(fid);
		
		printf("\n\tThe Employee Record File\n");
		for (i = 1; i <= lastrecno ; i++){
			readrec((char*)&emprec,i, fid);
			output_rec(emprec);
			}
		}


